/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */

/* Line 371 of yacc.c  */
#line 68 "src/lib/re_grammar.cpp"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif
/* "%code requires" blocks.  */
/* Line 387 of yacc.c  */
#line 1 "src/lib/re_grammar.ypp"

#include "parsenode.h"
#include "parsetree.h"
#include "parseutil.h"
#include "pattern.h"
#include "unicode.h"
#include "encoders/utf8.h"

#include <iomanip>
#include <sstream>
#include <string>
#include <vector>

namespace {
  struct Context {
    const int* Text;
    const int* TextBegin;
    const int* TextEnd;

    int TokenType;

    ParseTree* Tree;

    UnicodeSet USet;

    bool LiteralMode;
    bool CaseInsensitive;

    template <class... Args>
    ParseNode* add(Args&&... args) {
      return Tree->add(std::forward<Args>(args)...);
    }
  };

  union YYSTYPE {
    int c;
    ParseNode* node;
    UnicodeSet* s;
  };

  struct YYLTYPE {
    int first_line; // unused
    int first_column;
    int last_line;  // unused
    int last_column;
  };

  struct ParseError {
    enum {
      NONATOMIC_REPETITON,
      REVERSED_REPETITION_BOUNDS,
      INVALID_ESCAPE,
      UNMATCHED_PARENTHESIS,
      UNMATCHED_BRACKET,
      EMPTY_CHAR_CLASS,
      REVERSED_CHAR_RANGE_BOUNDS,
      REVERSED_BYTE_RANGE_BOUNDS,
      SET_OPERATOR_MISSING_OPERAND
    } Type;

    int Begin;
    int End;
    int First;
    int Second;

    ParseError(
      decltype(Type) type, int begin, int end, int first = -1, int second = -1
    ):
      Type(type), Begin(begin), End(end), First(first), Second(second)
    {}
  };

  static int yylex(YYSTYPE* yylval, YYLTYPE* yylloc, Context* ctx);
  static void yyerror(YYLTYPE* yylloc, Context* ctx, const char* msg);

  void throwError(ParseError e, Context* ctx);
}

#define YYLTYPE_IS_DECLARED 1
#define YYLTYPE_IS_TRIVIAL 1

#define YYDEBUG 0

#if YYDEBUG
extern int yydebug;
#endif


/* Line 387 of yacc.c  */
#line 186 "src/lib/re_grammar.cpp"

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 0,
     BYTE = 258,
     CHAR = 259,
     DIGIT = 260,
     HYPHEN_HYPHEN = 261,
     AMP_AMP = 262,
     TILDE_TILDE = 263,
     TEXT_START = 264,
     TEXT_END = 265,
     NON_WORD_BOUNDARY = 266,
     KILL = 267,
     WHACK_LITTLE_B = 268,
     BAD = 269,
     SET = 270,
     LEAST = 271,
     UNION = 272,
     XOR = 273,
     MINUS = 274,
     INTERSECT = 275
   };
#endif


#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (Context* ctx);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 256 "src/lib/re_grammar.cpp"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  66
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   571

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  39
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  17
/* YYNRULES -- Number of rules.  */
#define YYNRULES  125
/* YYNRULES -- Number of states.  */
#define YYNSTATES  158

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   275

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    33,     2,     2,    35,     2,     2,     2,
      29,    30,    23,    25,    28,    21,    36,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      31,    32,     2,    24,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    38,     2,    37,    34,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    26,    22,    27,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,    11,    13,    16,    19,    21,
      25,    29,    33,    39,    46,    54,    57,    60,    63,    68,
      74,    81,    83,    86,    90,    94,    97,   104,   111,   117,
     123,   125,   127,   129,   131,   133,   135,   137,   139,   141,
     143,   145,   147,   149,   151,   153,   155,   157,   159,   161,
     163,   165,   167,   169,   171,   175,   180,   184,   187,   192,
     196,   199,   204,   209,   212,   217,   222,   225,   230,   235,
     239,   245,   251,   255,   261,   267,   271,   277,   283,   285,
     288,   292,   296,   300,   304,   308,   312,   316,   318,   320,
     322,   325,   329,   333,   337,   339,   343,   347,   351,   355,
     357,   359,   361,   363,   365,   367,   369,   371,   373,   375,
     377,   379,   381,   383,   385,   387,   389,   391,   393,   395,
     397,   399,   401,   403,   405,   407
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      40,     0,    -1,    41,    -1,    42,    -1,    41,    22,    42,
      -1,    43,    -1,    42,    43,    -1,    42,    12,    -1,    45,
      -1,    45,    23,    24,    -1,    45,    25,    24,    -1,    45,
      24,    24,    -1,    45,    26,    44,    27,    24,    -1,    45,
      26,    44,    28,    27,    24,    -1,    45,    26,    44,    28,
      44,    27,    24,    -1,    45,    23,    -1,    45,    25,    -1,
      45,    24,    -1,    45,    26,    44,    27,    -1,    45,    26,
      44,    28,    27,    -1,    45,    26,    44,    28,    44,    27,
      -1,     5,    -1,    44,     5,    -1,    29,    41,    30,    -1,
      29,    41,     1,    -1,    29,     1,    -1,    29,    24,    31,
      32,    41,    30,    -1,    29,    24,    31,    33,    41,    30,
      -1,    29,    24,    32,    41,    30,    -1,    29,    24,    33,
      41,    30,    -1,    13,    -1,    11,    -1,     9,    -1,    10,
      -1,    34,    -1,    35,    -1,    46,    -1,     3,    -1,    47,
      -1,    36,    -1,     6,    -1,     7,    -1,     8,    -1,    48,
      -1,     4,    -1,     5,    -1,    37,    -1,    21,    -1,    26,
      -1,    27,    -1,    28,    -1,    31,    -1,    32,    -1,    33,
      -1,    38,    49,    37,    -1,    38,    34,    50,    37,    -1,
      38,    49,     1,    -1,    38,     1,    -1,    38,    34,    50,
       1,    -1,    38,    34,     1,    -1,    38,     7,    -1,    38,
      49,     7,    37,    -1,    38,    49,     7,     7,    -1,    38,
       6,    -1,    38,    49,     6,    37,    -1,    38,    49,     6,
       6,    -1,    38,     8,    -1,    38,    49,     8,    37,    -1,
      38,    49,     8,     8,    -1,    38,    34,     7,    -1,    38,
      34,    50,     7,    37,    -1,    38,    34,    50,     7,     7,
      -1,    38,    34,     6,    -1,    38,    34,    50,     6,    37,
      -1,    38,    34,    50,     6,     6,    -1,    38,    34,     8,
      -1,    38,    34,    50,     8,    37,    -1,    38,    34,    50,
       8,     8,    -1,    55,    -1,    49,    51,    -1,    49,     7,
      51,    -1,    49,     6,    51,    -1,    49,     8,    51,    -1,
      52,    21,    53,    -1,    52,    21,    48,    -1,     3,    21,
       3,    -1,     3,    21,    48,    -1,    48,    -1,    52,    -1,
       3,    -1,    50,    51,    -1,    50,     7,    51,    -1,    50,
       6,    51,    -1,    50,     8,    51,    -1,    51,    -1,    53,
      21,    53,    -1,    53,    21,    48,    -1,     3,    21,     3,
      -1,     3,    21,    48,    -1,    48,    -1,    53,    -1,    21,
      -1,     3,    -1,    37,    -1,    21,    -1,    54,    -1,    34,
      -1,    54,    -1,     4,    -1,     5,    -1,    22,    -1,    29,
      -1,    30,    -1,    24,    -1,    25,    -1,    23,    -1,    36,
      -1,    26,    -1,    27,    -1,    28,    -1,    31,    -1,    32,
      -1,    33,    -1,    35,    -1,    13,    -1,    15,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   134,   134,   141,   142,   149,   150,   154,   161,   162,
     166,   170,   174,   178,   182,   199,   203,   207,   211,   215,
     219,   239,   243,   251,   255,   265,   275,   279,   283,   287,
     291,   317,   343,   348,   353,   364,   375,   379,   383,   400,
     404,   413,   419,   425,   429,   430,   431,   435,   439,   443,
     447,   451,   455,   459,   466,   485,   536,   546,   556,   566,
     576,   586,   596,   606,   616,   626,   636,   646,   656,   666,
     676,   686,   696,   706,   716,   726,   736,   746,   756,   765,
     771,   777,   783,   789,   806,   812,   829,   835,   836,   841,
     849,   855,   861,   867,   873,   877,   894,   900,   917,   923,
     924,   929,   934,   942,   946,   950,   954,   958,   962,   963,
     964,   968,   972,   976,   980,   984,   988,   992,   996,  1000,
    1004,  1008,  1012,  1016,  1020,  1027
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of pattern\"", "error", "$undefined", "BYTE", "CHAR", "DIGIT",
  "HYPHEN_HYPHEN", "AMP_AMP", "TILDE_TILDE", "TEXT_START", "TEXT_END",
  "NON_WORD_BOUNDARY", "KILL", "WHACK_LITTLE_B", "\"invalid escape\"",
  "SET", "LEAST", "UNION", "XOR", "MINUS", "INTERSECT", "'-'", "'|'",
  "'*'", "'?'", "'+'", "'{'", "'}'", "','", "'('", "')'", "'<'", "'='",
  "'!'", "'^'", "'$'", "'.'", "']'", "'['", "$accept", "regexp", "alt",
  "concat", "rep", "number", "atom", "literal", "character", "charclass",
  "cc_expr_pos", "cc_expr_neg", "cc_atom", "cc_char_first",
  "cc_char_not_first", "cc_char", "cc_named", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,    45,   124,    42,    63,    43,   123,   125,    44,    40,
      41,    60,    61,    33,    94,    36,    46,    93,    91
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    39,    40,    41,    41,    42,    42,    42,    43,    43,
      43,    43,    43,    43,    43,    43,    43,    43,    43,    43,
      43,    44,    44,    45,    45,    45,    45,    45,    45,    45,
      45,    45,    45,    45,    45,    45,    45,    46,    46,    46,
      46,    46,    46,    46,    47,    47,    47,    47,    47,    47,
      47,    47,    47,    47,    48,    48,    48,    48,    48,    48,
      48,    48,    48,    48,    48,    48,    48,    48,    48,    48,
      48,    48,    48,    48,    48,    48,    48,    48,    48,    49,
      49,    49,    49,    49,    49,    49,    49,    49,    49,    49,
      50,    50,    50,    50,    50,    51,    51,    51,    51,    51,
      51,    51,    51,    52,    52,    52,    53,    53,    54,    54,
      54,    54,    54,    54,    54,    54,    54,    54,    54,    54,
      54,    54,    54,    54,    54,    55
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     3,     1,     2,     2,     1,     3,
       3,     3,     5,     6,     7,     2,     2,     2,     4,     5,
       6,     1,     2,     3,     3,     2,     6,     6,     5,     5,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     4,     3,     2,     4,     3,
       2,     4,     4,     2,     4,     4,     2,     4,     4,     3,
       5,     5,     3,     5,     5,     3,     5,     5,     1,     2,
       3,     3,     3,     3,     3,     3,     3,     1,     1,     1,
       2,     3,     3,     3,     1,     3,     3,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,    37,    44,    45,    40,    41,    42,    32,    33,    31,
      30,   125,    47,    48,    49,    50,     0,    51,    52,    53,
      34,    35,    39,    46,     0,     0,     2,     3,     5,     8,
      36,    38,    43,    78,    25,     0,     0,    57,    89,   108,
     109,    63,    60,    66,   124,   104,   110,   115,   113,   114,
     117,   118,   119,   111,   112,   120,   121,   122,     0,   123,
     116,   103,    87,     0,    88,   105,     1,     0,     7,     6,
      15,    17,    16,     0,     0,     0,     0,    24,    23,     0,
      59,   102,    72,    69,    75,   101,   106,    99,     0,    94,
     100,   107,    56,     0,     0,     0,    54,    79,     0,     4,
       9,    11,    10,    21,     0,     0,     0,     0,     0,    85,
      86,     0,    58,     0,     0,     0,    55,    90,     0,    65,
      64,    81,    62,    61,    80,    68,    67,    82,    84,    83,
      22,    18,     0,     0,     0,    28,    29,    97,    98,    74,
      73,    92,    71,    70,    91,    77,    76,    93,    96,    95,
      12,    19,     0,    26,    27,    13,    20,    14
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,    25,    26,    27,    28,   104,    29,    30,    31,    32,
      63,    88,    89,    64,    90,    91,    33
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -58
static const yytype_int16 yypact[] =
{
     282,   -58,   -58,   -58,   -58,   -58,   -58,   -58,   -58,   -58,
     -58,   -58,   -58,   -58,   -58,   -58,   208,   -58,   -58,   -58,
     -58,   -58,   -58,   -58,    94,     9,    -8,    14,   -58,    80,
     -58,   -58,   -58,   -58,   -58,    45,    53,   -58,    -5,   -58,
     -58,   -58,   -58,   -58,   -58,   -58,   -58,   -58,   -58,   -58,
     -58,   -58,   -58,   -58,   -58,   -58,   -58,   -58,   246,   -58,
     -58,   -58,   -58,   132,     7,   -58,   -58,   282,   -58,   -58,
      37,    42,    44,    67,    52,   282,   282,   -58,   -58,    29,
     -58,    58,   -58,   -58,   -58,   -58,   -58,   -58,   170,   -58,
      65,   -58,   -58,   318,   354,   390,   -58,   -58,   533,    14,
     -58,   -58,   -58,   -58,    54,   282,   282,   -20,   -18,   -58,
     -58,    50,   -58,   426,   462,   498,   -58,   -58,   533,   -58,
     -58,   -58,   -58,   -58,   -58,   -58,   -58,   -58,   -58,   -58,
     -58,    72,     3,   -17,   -15,   -58,   -58,   -58,   -58,   -58,
     -58,   -58,   -58,   -58,   -58,   -58,   -58,   -58,   -58,   -58,
     -58,    84,     6,   -58,   -58,   -58,    86,   -58
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -58,   -58,   -13,    46,   -26,   -21,   -58,   -58,   -58,   -24,
     -58,   -58,   -57,   -58,   -38,    88,   -58
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
      62,    69,    67,    36,    67,    67,    97,    67,   103,    66,
     135,   130,   136,   153,    67,   154,    79,     1,     2,     3,
       4,     5,     6,     7,     8,     9,    68,    10,    98,    11,
     151,   117,   109,   156,    87,    12,   121,   124,   127,    87,
      13,    14,    15,    16,    11,    17,    18,    19,    20,    21,
      22,    23,    24,   137,    77,   110,   141,   144,   147,   130,
     129,   100,   107,   108,    87,    11,   101,    24,   102,    87,
      87,    87,   103,    69,   128,    67,    74,    75,    76,   111,
     149,   131,   132,    78,   105,   106,   118,   138,    24,    87,
      87,    87,   133,   134,   148,    37,   150,    38,    39,    40,
      41,    42,    43,    70,    71,    72,    73,    44,   155,    11,
     157,   152,    65,    99,     0,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    24,    92,     0,    81,    39,    40,    93,    94,
      95,     0,     0,     0,     0,    44,     0,    11,     0,     0,
       0,     0,     0,    85,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    86,    59,    60,    96,
      24,   112,     0,    81,    39,    40,   113,   114,   115,     0,
       0,     0,     0,    44,     0,    11,     0,     0,     0,     0,
       0,    85,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    86,    59,    60,   116,    24,    34,
       0,     1,     2,     3,     4,     5,     6,     7,     8,     9,
       0,    10,     0,    11,     0,     0,     0,     0,     0,    12,
       0,     0,    35,     0,    13,    14,    15,    16,     0,    17,
      18,    19,    20,    21,    22,    23,    24,    80,     0,    81,
      39,    40,    82,    83,    84,     0,     0,     0,     0,    44,
       0,    11,     0,     0,     0,     0,     0,    85,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      86,    59,    60,     0,    24,     1,     2,     3,     4,     5,
       6,     7,     8,     9,     0,    10,     0,    11,     0,     0,
       0,     0,     0,    12,     0,     0,     0,     0,    13,    14,
      15,    16,     0,    17,    18,    19,    20,    21,    22,    23,
      24,    81,    39,    40,   119,     0,     0,     0,     0,     0,
       0,    44,     0,    11,     0,     0,     0,     0,     0,    85,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    86,    59,    60,   120,    24,    81,    39,    40,
       0,   122,     0,     0,     0,     0,     0,    44,     0,    11,
       0,     0,     0,     0,     0,    85,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    86,    59,
      60,   123,    24,    81,    39,    40,     0,     0,   125,     0,
       0,     0,     0,    44,     0,    11,     0,     0,     0,     0,
       0,    85,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    86,    59,    60,   126,    24,    81,
      39,    40,   139,     0,     0,     0,     0,     0,     0,    44,
       0,    11,     0,     0,     0,     0,     0,    85,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      86,    59,    60,   140,    24,    81,    39,    40,     0,   142,
       0,     0,     0,     0,     0,    44,     0,    11,     0,     0,
       0,     0,     0,    85,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    86,    59,    60,   143,
      24,    81,    39,    40,     0,     0,   145,     0,     0,     0,
       0,    44,     0,    11,     0,     0,     0,     0,     0,    85,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    86,    59,    60,   146,    24,    39,    40,     0,
       0,     0,     0,     0,     0,     0,    44,     0,    11,     0,
       0,     0,     0,     0,     0,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    86,    59,    60,
       0,    24
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-58)))

#define yytable_value_is_error(Yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
      24,    27,    22,    16,    22,    22,    63,    22,     5,     0,
      30,     5,    30,    30,    22,    30,    21,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    21,    15,
      27,    88,     3,    27,    58,    21,    93,    94,    95,    63,
      26,    27,    28,    29,    15,    31,    32,    33,    34,    35,
      36,    37,    38,     3,     1,    79,   113,   114,   115,     5,
      98,    24,    75,    76,    88,    15,    24,    38,    24,    93,
      94,    95,     5,    99,    98,    22,    31,    32,    33,    21,
     118,    27,    28,    30,    32,    33,    21,   111,    38,   113,
     114,   115,   105,   106,   118,     1,    24,     3,     4,     5,
       6,     7,     8,    23,    24,    25,    26,    13,    24,    15,
      24,   132,    24,    67,    -1,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,     1,    -1,     3,     4,     5,     6,     7,
       8,    -1,    -1,    -1,    -1,    13,    -1,    15,    -1,    -1,
      -1,    -1,    -1,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,     1,    -1,     3,     4,     5,     6,     7,     8,    -1,
      -1,    -1,    -1,    13,    -1,    15,    -1,    -1,    -1,    -1,
      -1,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,     1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      -1,    13,    -1,    15,    -1,    -1,    -1,    -1,    -1,    21,
      -1,    -1,    24,    -1,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,     1,    -1,     3,
       4,     5,     6,     7,     8,    -1,    -1,    -1,    -1,    13,
      -1,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    -1,    38,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    -1,    13,    -1,    15,    -1,    -1,
      -1,    -1,    -1,    21,    -1,    -1,    -1,    -1,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,     3,     4,     5,     6,    -1,    -1,    -1,    -1,    -1,
      -1,    13,    -1,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,     3,     4,     5,
      -1,     7,    -1,    -1,    -1,    -1,    -1,    13,    -1,    15,
      -1,    -1,    -1,    -1,    -1,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,     3,     4,     5,    -1,    -1,     8,    -1,
      -1,    -1,    -1,    13,    -1,    15,    -1,    -1,    -1,    -1,
      -1,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,     3,
       4,     5,     6,    -1,    -1,    -1,    -1,    -1,    -1,    13,
      -1,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,     3,     4,     5,    -1,     7,
      -1,    -1,    -1,    -1,    -1,    13,    -1,    15,    -1,    -1,
      -1,    -1,    -1,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,     3,     4,     5,    -1,    -1,     8,    -1,    -1,    -1,
      -1,    13,    -1,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,     4,     5,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    13,    -1,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      -1,    38
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      13,    15,    21,    26,    27,    28,    29,    31,    32,    33,
      34,    35,    36,    37,    38,    40,    41,    42,    43,    45,
      46,    47,    48,    55,     1,    24,    41,     1,     3,     4,
       5,     6,     7,     8,    13,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    48,    49,    52,    54,     0,    22,    12,    43,
      23,    24,    25,    26,    31,    32,    33,     1,    30,    21,
       1,     3,     6,     7,     8,    21,    34,    48,    50,    51,
      53,    54,     1,     6,     7,     8,    37,    51,    21,    42,
      24,    24,    24,     5,    44,    32,    33,    41,    41,     3,
      48,    21,     1,     6,     7,     8,    37,    51,    21,     6,
      37,    51,     7,    37,    51,     8,    37,    51,    48,    53,
       5,    27,    28,    41,    41,    30,    30,     3,    48,     6,
      37,    51,     7,    37,    51,     8,    37,    51,    48,    53,
      24,    27,    44,    30,    30,    24,    27,    24
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, ctx, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (YYID (N))                                                     \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (YYID (0))
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

__attribute__((__unused__))
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
#else
static unsigned
yy_location_print_ (yyo, yylocp)
    FILE *yyo;
    YYLTYPE const * const yylocp;
#endif
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += fprintf (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += fprintf (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += fprintf (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += fprintf (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += fprintf (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, &yylloc, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, &yylloc, ctx)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location, ctx); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, Context* ctx)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, ctx)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    Context* ctx;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
  YYUSE (ctx);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, Context* ctx)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp, ctx)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    Context* ctx;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, ctx);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, Context* ctx)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule, ctx)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
    Context* ctx;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       , ctx);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule, ctx); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, Context* ctx)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp, ctx)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
    Context* ctx;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (ctx);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (Context* ctx)
#else
int
yyparse (ctx)
    Context* ctx;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;


#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
static YYSTYPE yyval_default;
# define YY_INITIAL_VALUE(Value) = Value
#endif
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc = yyloc_default;


    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1792 of yacc.c  */
#line 135 "src/lib/re_grammar.ypp"
    {
    ctx->Tree->Root = (yyval.node) = ctx->add(ParseNode::REGEXP, (yyvsp[(1) - (1)].node));
  }
    break;

  case 4:
/* Line 1792 of yacc.c  */
#line 143 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = ctx->add(ParseNode::ALTERNATION, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node));
  }
    break;

  case 6:
/* Line 1792 of yacc.c  */
#line 151 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = ctx->add(ParseNode::CONCATENATION, (yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node));
  }
    break;

  case 7:
/* Line 1792 of yacc.c  */
#line 155 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = ctx->add(ParseNode::LOOKBEHIND_POS, (yyvsp[(1) - (2)].node));
  }
    break;

  case 9:
/* Line 1792 of yacc.c  */
#line 163 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = ctx->add(ParseNode::REPETITION_NG, (yyvsp[(1) - (3)].node), 0, UNBOUNDED);
  }
    break;

  case 10:
/* Line 1792 of yacc.c  */
#line 167 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = ctx->add(ParseNode::REPETITION_NG, (yyvsp[(1) - (3)].node), 1, UNBOUNDED);
  }
    break;

  case 11:
/* Line 1792 of yacc.c  */
#line 171 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = ctx->add(ParseNode::REPETITION_NG, (yyvsp[(1) - (3)].node), 0, 1);
  }
    break;

  case 12:
/* Line 1792 of yacc.c  */
#line 175 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = ctx->add(ParseNode::REPETITION_NG, (yyvsp[(1) - (5)].node), (yyvsp[(3) - (5)].node)->Val, (yyvsp[(3) - (5)].node)->Val);
  }
    break;

  case 13:
/* Line 1792 of yacc.c  */
#line 179 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = ctx->add(ParseNode::REPETITION_NG, (yyvsp[(1) - (6)].node), (yyvsp[(3) - (6)].node)->Val, UNBOUNDED);
  }
    break;

  case 14:
/* Line 1792 of yacc.c  */
#line 183 "src/lib/re_grammar.ypp"
    {
    if ((yyvsp[(3) - (7)].node)->Val > (yyvsp[(5) - (7)].node)->Val) {
      // {n,m} is ill-formed when n > m
      throwError(
        {
          ParseError::REVERSED_REPETITION_BOUNDS,
          (yylsp[(2) - (7)]).first_column, (yylsp[(7) - (7)]).last_column,
          (yyvsp[(3) - (7)].node)->Val, (yyvsp[(5) - (7)].node)->Val
        },
        ctx
      );
    }
    else {
      (yyval.node) = ctx->add(ParseNode::REPETITION_NG, (yyvsp[(1) - (7)].node), (yyvsp[(3) - (7)].node)->Val, (yyvsp[(5) - (7)].node)->Val);
    }
  }
    break;

  case 15:
/* Line 1792 of yacc.c  */
#line 200 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = ctx->add(ParseNode::REPETITION, (yyvsp[(1) - (2)].node), 0, UNBOUNDED);
  }
    break;

  case 16:
/* Line 1792 of yacc.c  */
#line 204 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = ctx->add(ParseNode::REPETITION, (yyvsp[(1) - (2)].node), 1, UNBOUNDED);
  }
    break;

  case 17:
/* Line 1792 of yacc.c  */
#line 208 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = ctx->add(ParseNode::REPETITION, (yyvsp[(1) - (2)].node), 0, 1);
  }
    break;

  case 18:
/* Line 1792 of yacc.c  */
#line 212 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = ctx->add(ParseNode::REPETITION, (yyvsp[(1) - (4)].node), (yyvsp[(3) - (4)].node)->Val, (yyvsp[(3) - (4)].node)->Val);
  }
    break;

  case 19:
/* Line 1792 of yacc.c  */
#line 216 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = ctx->add(ParseNode::REPETITION, (yyvsp[(1) - (5)].node), (yyvsp[(3) - (5)].node)->Val, UNBOUNDED);
  }
    break;

  case 20:
/* Line 1792 of yacc.c  */
#line 220 "src/lib/re_grammar.ypp"
    {
    if ((yyvsp[(3) - (6)].node)->Val > (yyvsp[(5) - (6)].node)->Val) {
      // {n,m} is ill-formed when n > m
      throwError(
        {
          ParseError::REVERSED_REPETITION_BOUNDS,
          (yylsp[(2) - (6)]).first_column, (yylsp[(6) - (6)]).last_column,
          (yyvsp[(3) - (6)].node)->Val, (yyvsp[(5) - (6)].node)->Val,
        },
        ctx
      );
    }
    else {
      (yyval.node) = ctx->add(ParseNode::REPETITION, (yyvsp[(1) - (6)].node), (yyvsp[(3) - (6)].node)->Val, (yyvsp[(5) - (6)].node)->Val);
    }
  }
    break;

  case 21:
/* Line 1792 of yacc.c  */
#line 240 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = ctx->add(ParseNode::TEMPORARY, (yyvsp[(1) - (1)].c) - 48);
  }
    break;

  case 22:
/* Line 1792 of yacc.c  */
#line 244 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = (yyvsp[(1) - (2)].node);
    (yyval.node)->Val = (yyval.node)->Val*10 + ((yyvsp[(2) - (2)].c) - 48);
  }
    break;

  case 23:
/* Line 1792 of yacc.c  */
#line 252 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = (yyvsp[(2) - (3)].node);
  }
    break;

  case 24:
/* Line 1792 of yacc.c  */
#line 256 "src/lib/re_grammar.ypp"
    {
    throwError(
      {
        ParseError::UNMATCHED_PARENTHESIS,
        (yylsp[(1) - (3)]).first_column, (yylsp[(1) - (3)]).last_column
      },
      ctx
    );
  }
    break;

  case 25:
/* Line 1792 of yacc.c  */
#line 266 "src/lib/re_grammar.ypp"
    {
    throwError(
      {
        ParseError::UNMATCHED_PARENTHESIS,
        (yylsp[(1) - (2)]).first_column, (yylsp[(1) - (2)]).last_column
      },
      ctx
    );
  }
    break;

  case 26:
/* Line 1792 of yacc.c  */
#line 276 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = ctx->add(ParseNode::LOOKBEHIND_POS, (yyvsp[(5) - (6)].node));
  }
    break;

  case 27:
/* Line 1792 of yacc.c  */
#line 280 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = ctx->add(ParseNode::LOOKBEHIND_NEG, (yyvsp[(5) - (6)].node));
  }
    break;

  case 28:
/* Line 1792 of yacc.c  */
#line 284 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = ctx->add(ParseNode::LOOKAHEAD_POS, (yyvsp[(4) - (5)].node));
  }
    break;

  case 29:
/* Line 1792 of yacc.c  */
#line 288 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = ctx->add(ParseNode::LOOKAHEAD_NEG, (yyvsp[(4) - (5)].node));
  }
    break;

  case 30:
/* Line 1792 of yacc.c  */
#line 292 "src/lib/re_grammar.ypp"
    {
    // \b  = ((?<!\w)(?!\W)|(?<!\W)(?!\w))

    ctx->USet.reset();
    ctx->USet.insert('0', '9' + 1);
    ctx->USet.insert('A', 'Z' + 1);
    ctx->USet.set('_');
    ctx->USet.insert('a', 'z' + 1);
    ParseNode* w = ctx->add(ParseNode::CHAR_CLASS, ctx->USet);

    ctx->USet.flip();
    ParseNode* W = ctx->add(ParseNode::CHAR_CLASS, ctx->USet);

    ParseNode* nlw = ctx->add(ParseNode::LOOKBEHIND_NEG, w);
    ParseNode* nrW = ctx->add(ParseNode::LOOKAHEAD_NEG, W);
    ParseNode* l = ctx->add(ParseNode::CONCATENATION, nlw, nrW);

    W = ctx->add(*W);
    w = ctx->add(*w);
    ParseNode* nlW = ctx->add(ParseNode::LOOKBEHIND_NEG, W);
    ParseNode* nrw = ctx->add(ParseNode::LOOKAHEAD_NEG, w);
    ParseNode* r = ctx->add(ParseNode::CONCATENATION, nlW, nrw);

    (yyval.node) = ctx->add(ParseNode::ALTERNATION, l, r);
  }
    break;

  case 31:
/* Line 1792 of yacc.c  */
#line 318 "src/lib/re_grammar.ypp"
    {
    // \B  = ((?<!\w)(?!\w)|(?<!\W)(?!\W))

    ctx->USet.reset();
    ctx->USet.insert('0', '9' + 1);
    ctx->USet.insert('A', 'Z' + 1);
    ctx->USet.set('_');
    ctx->USet.insert('a', 'z' + 1);
    ParseNode* w = ctx->add(ParseNode::CHAR_CLASS, ctx->USet);

    ctx->USet.flip();
    ParseNode* W = ctx->add(ParseNode::CHAR_CLASS, ctx->USet);

    ParseNode* nlw = ctx->add(ParseNode::LOOKBEHIND_NEG, w);
    w = ctx->add(*w);
    ParseNode* nrw = ctx->add(ParseNode::LOOKAHEAD_NEG, w);
    ParseNode* l = ctx->add(ParseNode::CONCATENATION, nlw, nrw);

    ParseNode* nlW = ctx->add(ParseNode::LOOKBEHIND_NEG, W);
    W = ctx->add(*W);
    ParseNode* nrW = ctx->add(ParseNode::LOOKAHEAD_NEG, W);
    ParseNode* r = ctx->add(ParseNode::CONCATENATION, nlW, nrW);

    (yyval.node) = ctx->add(ParseNode::ALTERNATION, l, r);
  }
    break;

  case 32:
/* Line 1792 of yacc.c  */
#line 344 "src/lib/re_grammar.ypp"
    {
    ParseNode *dot = ctx->add(ParseNode::DOT, '.');
    (yyval.node) = ctx->add(ParseNode::LOOKBEHIND_NEG, dot);
  }
    break;

  case 33:
/* Line 1792 of yacc.c  */
#line 349 "src/lib/re_grammar.ypp"
    {
    ParseNode *dot = ctx->add(ParseNode::DOT, '.');
    (yyval.node) = ctx->add(ParseNode::LOOKAHEAD_NEG, dot);
  }
    break;

  case 34:
/* Line 1792 of yacc.c  */
#line 354 "src/lib/re_grammar.ypp"
    {
    ctx->USet.reset();
    ctx->USet.insert('\n', '\r' + 1); // \n \v \f \r
    ctx->USet.set(0x85);              // NEL
    ctx->USet.set(0x2028);            // LINE SEPARATOR
    ctx->USet.set(0x2029);            // PARAGRAPH SEPARATOR

    ParseNode *linebreak = ctx->add(ParseNode::CHAR_CLASS, ctx->USet);
    (yyval.node) = ctx->add(ParseNode::LOOKBEHIND_NEG, linebreak);
  }
    break;

  case 35:
/* Line 1792 of yacc.c  */
#line 365 "src/lib/re_grammar.ypp"
    {
    ctx->USet.reset();
    ctx->USet.insert('\n', '\r' + 1); // \n \v \f \r
    ctx->USet.set(0x85);              // NEL
    ctx->USet.set(0x2028);            // LINE SEPARATOR
    ctx->USet.set(0x2029);            // PARAGRAPH SEPARATOR

    ParseNode *linebreak = ctx->add(ParseNode::CHAR_CLASS, ctx->USet);
    (yyval.node) = ctx->add(ParseNode::LOOKAHEAD_NEG, linebreak);
  }
    break;

  case 37:
/* Line 1792 of yacc.c  */
#line 380 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = ctx->add(ParseNode::BYTE, (yyvsp[(1) - (1)].c));
  }
    break;

  case 38:
/* Line 1792 of yacc.c  */
#line 384 "src/lib/re_grammar.ypp"
    {
    if (ctx->CaseInsensitive) {
      ctx->USet.reset();
      ctx->USet.set((yyvsp[(1) - (1)].c));
      if (caseDesensitize(ctx->USet)) {
        // TODO: Maybe handle the commmon ASCII case without going via USet?
        (yyval.node) = ctx->add(ParseNode::CHAR_CLASS, ctx->USet);
      }
      else {
        (yyval.node) = ctx->add(ParseNode::LITERAL, (yyvsp[(1) - (1)].c));
      }
    }
    else {
      (yyval.node) = ctx->add(ParseNode::LITERAL, (yyvsp[(1) - (1)].c));
    }
  }
    break;

  case 39:
/* Line 1792 of yacc.c  */
#line 401 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = ctx->add(ParseNode::DOT, '.');
  }
    break;

  case 40:
/* Line 1792 of yacc.c  */
#line 405 "src/lib/re_grammar.ypp"
    {
    // This special case exists because -- is the set minus operator inside
    // character classes. Parsing -- together helps disambiguate set minus
    // from ranges. Here, outside of a char class, -- is just two hyphens.
    ParseNode* l = ctx->add(ParseNode::LITERAL, '-');
    ParseNode* r = ctx->add(ParseNode::LITERAL, '-');
    (yyval.node) = ctx->add(ParseNode::CONCATENATION, l, r);
  }
    break;

  case 41:
/* Line 1792 of yacc.c  */
#line 414 "src/lib/re_grammar.ypp"
    {
    ParseNode* l = ctx->add(ParseNode::LITERAL, '&');
    ParseNode* r = ctx->add(ParseNode::LITERAL, '&');
    (yyval.node) = ctx->add(ParseNode::CONCATENATION, l, r);
  }
    break;

  case 42:
/* Line 1792 of yacc.c  */
#line 420 "src/lib/re_grammar.ypp"
    {
    ParseNode* l = ctx->add(ParseNode::LITERAL, '~');
    ParseNode* r = ctx->add(ParseNode::LITERAL, '~');
    (yyval.node) = ctx->add(ParseNode::CONCATENATION, l, r);
  }
    break;

  case 46:
/* Line 1792 of yacc.c  */
#line 432 "src/lib/re_grammar.ypp"
    {
    (yyval.c) = ']';
  }
    break;

  case 47:
/* Line 1792 of yacc.c  */
#line 436 "src/lib/re_grammar.ypp"
    {
    (yyval.c) = '-';
  }
    break;

  case 48:
/* Line 1792 of yacc.c  */
#line 440 "src/lib/re_grammar.ypp"
    {
    (yyval.c) = '{';
  }
    break;

  case 49:
/* Line 1792 of yacc.c  */
#line 444 "src/lib/re_grammar.ypp"
    {
    (yyval.c) = '}';
  }
    break;

  case 50:
/* Line 1792 of yacc.c  */
#line 448 "src/lib/re_grammar.ypp"
    {
    (yyval.c) = ',';
  }
    break;

  case 51:
/* Line 1792 of yacc.c  */
#line 452 "src/lib/re_grammar.ypp"
    {
    (yyval.c) = '<';
  }
    break;

  case 52:
/* Line 1792 of yacc.c  */
#line 456 "src/lib/re_grammar.ypp"
    {
    (yyval.c) = '=';
  }
    break;

  case 53:
/* Line 1792 of yacc.c  */
#line 460 "src/lib/re_grammar.ypp"
    {
    (yyval.c) = '!';
  }
    break;

  case 54:
/* Line 1792 of yacc.c  */
#line 467 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = (yyvsp[(2) - (3)].node);

    if (ctx->CaseInsensitive) {
      caseDesensitize((yyval.node)->Set.CodePoints);
    }

    if ((yyval.node)->Set.CodePoints.none() && (yyval.node)->Set.Breakout.Bytes.none()) {
      // empty character class
      throwError(
        {
          ParseError::EMPTY_CHAR_CLASS,
          (yylsp[(1) - (3)]).first_column, (yylsp[(3) - (3)]).last_column
        },
        ctx
      );
    }
  }
    break;

  case 55:
/* Line 1792 of yacc.c  */
#line 486 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = (yyvsp[(3) - (4)].node);

    if ((yyval.node)->Set.CodePoints.any()) {
      // NB: PCRE applies case-insensitivity first, then negation. This is
      // important, as these two operations do not commute on a cc such as
      // [^a]. Let U be the set of all Unicode code points. Negating first
      // gives U / {a}, which becomes U again when closing under case-
      // insensitivity, due to A being a member of U / {a}, while closing
      // under case-insensitivity first gives {A, a}, which becomes
      // U / {A, a} after negation.

      if (ctx->CaseInsensitive) {
        caseDesensitize((yyval.node)->Set.CodePoints);
      }

      (yyval.node)->Set.CodePoints.flip();
      if ((yyval.node)->Set.CodePoints.none()) {
        // empty character class
        throwError(
          {
            ParseError::EMPTY_CHAR_CLASS,
            (yylsp[(1) - (4)]).first_column, (yylsp[(4) - (4)]).last_column,
          },
          ctx
        );
      }

      if ((yyval.node)->Set.Breakout.Bytes.any()) {
        (yyval.node)->Set.Breakout.Additive = false;
      }
    }
    else if ((yyval.node)->Set.Breakout.Bytes.any()) {
      (yyval.node)->Set.Breakout.Bytes.flip();
      if ((yyval.node)->Set.Breakout.Bytes.none()) {
        // empty character class
        throwError(
          {
            ParseError::EMPTY_CHAR_CLASS,
            (yylsp[(1) - (4)]).first_column, (yylsp[(4) - (4)]).last_column,
          },
          ctx
        );
      }
    }
    else {
      // empty inner character class
      (yyval.node)->Set.CodePoints.flip();
    }
  }
    break;

  case 56:
/* Line 1792 of yacc.c  */
#line 537 "src/lib/re_grammar.ypp"
    {
    throwError(
      {
        ParseError::UNMATCHED_BRACKET,
        (yylsp[(1) - (3)]).first_column, (yylsp[(1) - (3)]).last_column
      },
      ctx
    );
  }
    break;

  case 57:
/* Line 1792 of yacc.c  */
#line 547 "src/lib/re_grammar.ypp"
    {
    throwError(
      {
        ParseError::UNMATCHED_BRACKET,
        (yylsp[(1) - (2)]).first_column, (yylsp[(1) - (2)]).last_column
      },
      ctx
    );
  }
    break;

  case 58:
/* Line 1792 of yacc.c  */
#line 557 "src/lib/re_grammar.ypp"
    {
    throwError(
      {
        ParseError::UNMATCHED_BRACKET,
        (yylsp[(1) - (4)]).first_column, (yylsp[(1) - (4)]).last_column
      },
      ctx
    );
  }
    break;

  case 59:
/* Line 1792 of yacc.c  */
#line 567 "src/lib/re_grammar.ypp"
    {
    throwError(
      {
        ParseError::UNMATCHED_BRACKET,
        (yylsp[(1) - (3)]).first_column, (yylsp[(1) - (3)]).last_column
      },
      ctx
    );
  }
    break;

  case 60:
/* Line 1792 of yacc.c  */
#line 577 "src/lib/re_grammar.ypp"
    {
    throwError(
      {
        ParseError::SET_OPERATOR_MISSING_OPERAND,
        (yylsp[(2) - (2)]).first_column, (yylsp[(2) - (2)]).last_column
      },
      ctx
    );
  }
    break;

  case 61:
/* Line 1792 of yacc.c  */
#line 587 "src/lib/re_grammar.ypp"
    {
    throwError(
      {
        ParseError::SET_OPERATOR_MISSING_OPERAND,
        (yylsp[(3) - (4)]).first_column, (yylsp[(3) - (4)]).last_column
      },
      ctx
    );
  }
    break;

  case 62:
/* Line 1792 of yacc.c  */
#line 597 "src/lib/re_grammar.ypp"
    {
    throwError(
      {
        ParseError::SET_OPERATOR_MISSING_OPERAND,
        (yylsp[(3) - (4)]).first_column, (yylsp[(3) - (4)]).last_column
      },
      ctx
    );
  }
    break;

  case 63:
/* Line 1792 of yacc.c  */
#line 607 "src/lib/re_grammar.ypp"
    {
    throwError(
      {
        ParseError::SET_OPERATOR_MISSING_OPERAND,
        (yylsp[(2) - (2)]).first_column, (yylsp[(2) - (2)]).last_column
      },
      ctx
    );
  }
    break;

  case 64:
/* Line 1792 of yacc.c  */
#line 617 "src/lib/re_grammar.ypp"
    {
    throwError(
      {
        ParseError::SET_OPERATOR_MISSING_OPERAND,
        (yylsp[(3) - (4)]).first_column, (yylsp[(3) - (4)]).last_column
      },
      ctx
    );
  }
    break;

  case 65:
/* Line 1792 of yacc.c  */
#line 627 "src/lib/re_grammar.ypp"
    {
    throwError(
      {
        ParseError::SET_OPERATOR_MISSING_OPERAND,
        (yylsp[(3) - (4)]).first_column, (yylsp[(3) - (4)]).last_column
      },
      ctx
    );
  }
    break;

  case 66:
/* Line 1792 of yacc.c  */
#line 637 "src/lib/re_grammar.ypp"
    {
    throwError(
      {
        ParseError::SET_OPERATOR_MISSING_OPERAND,
        (yylsp[(2) - (2)]).first_column, (yylsp[(2) - (2)]).last_column
      },
      ctx
    );
  }
    break;

  case 67:
/* Line 1792 of yacc.c  */
#line 647 "src/lib/re_grammar.ypp"
    {
    throwError(
      {
        ParseError::SET_OPERATOR_MISSING_OPERAND,
        (yylsp[(3) - (4)]).first_column, (yylsp[(3) - (4)]).last_column
      },
      ctx
    );
  }
    break;

  case 68:
/* Line 1792 of yacc.c  */
#line 657 "src/lib/re_grammar.ypp"
    {
    throwError(
      {
        ParseError::SET_OPERATOR_MISSING_OPERAND,
        (yylsp[(3) - (4)]).first_column, (yylsp[(3) - (4)]).last_column
      },
      ctx
    );
  }
    break;

  case 69:
/* Line 1792 of yacc.c  */
#line 667 "src/lib/re_grammar.ypp"
    {
    throwError(
      {
        ParseError::SET_OPERATOR_MISSING_OPERAND,
        (yylsp[(3) - (3)]).first_column, (yylsp[(3) - (3)]).last_column
      },
      ctx
    );
  }
    break;

  case 70:
/* Line 1792 of yacc.c  */
#line 677 "src/lib/re_grammar.ypp"
    {
    throwError(
      {
        ParseError::SET_OPERATOR_MISSING_OPERAND,
        (yylsp[(4) - (5)]).first_column, (yylsp[(4) - (5)]).last_column
      },
      ctx
    );
  }
    break;

  case 71:
/* Line 1792 of yacc.c  */
#line 687 "src/lib/re_grammar.ypp"
    {
    throwError(
      {
        ParseError::SET_OPERATOR_MISSING_OPERAND,
        (yylsp[(4) - (5)]).first_column, (yylsp[(4) - (5)]).last_column
      },
      ctx
    );
  }
    break;

  case 72:
/* Line 1792 of yacc.c  */
#line 697 "src/lib/re_grammar.ypp"
    {
    throwError(
      {
        ParseError::SET_OPERATOR_MISSING_OPERAND,
        (yylsp[(3) - (3)]).first_column, (yylsp[(3) - (3)]).last_column
      },
      ctx
    );
  }
    break;

  case 73:
/* Line 1792 of yacc.c  */
#line 707 "src/lib/re_grammar.ypp"
    {
    throwError(
      {
        ParseError::SET_OPERATOR_MISSING_OPERAND,
        (yylsp[(4) - (5)]).first_column, (yylsp[(4) - (5)]).last_column
      },
      ctx
    );
  }
    break;

  case 74:
/* Line 1792 of yacc.c  */
#line 717 "src/lib/re_grammar.ypp"
    {
    throwError(
      {
        ParseError::SET_OPERATOR_MISSING_OPERAND,
        (yylsp[(4) - (5)]).first_column, (yylsp[(4) - (5)]).last_column
      },
      ctx
    );
  }
    break;

  case 75:
/* Line 1792 of yacc.c  */
#line 727 "src/lib/re_grammar.ypp"
    {
    throwError(
      {
        ParseError::SET_OPERATOR_MISSING_OPERAND,
        (yylsp[(3) - (3)]).first_column, (yylsp[(3) - (3)]).last_column
      },
      ctx
    );
  }
    break;

  case 76:
/* Line 1792 of yacc.c  */
#line 737 "src/lib/re_grammar.ypp"
    {
    throwError(
      {
        ParseError::SET_OPERATOR_MISSING_OPERAND,
        (yylsp[(4) - (5)]).first_column, (yylsp[(4) - (5)]).last_column
      },
      ctx
    );
  }
    break;

  case 77:
/* Line 1792 of yacc.c  */
#line 747 "src/lib/re_grammar.ypp"
    {
    throwError(
      {
        ParseError::SET_OPERATOR_MISSING_OPERAND,
        (yylsp[(4) - (5)]).first_column, (yylsp[(4) - (5)]).last_column
      },
      ctx
    );
  }
    break;

  case 78:
/* Line 1792 of yacc.c  */
#line 757 "src/lib/re_grammar.ypp"
    {
    if (ctx->CaseInsensitive) {
      caseDesensitize((yyval.node)->Set.CodePoints);
    }
  }
    break;

  case 79:
/* Line 1792 of yacc.c  */
#line 766 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = (yyvsp[(1) - (2)].node);
    (yyval.node)->Set.CodePoints |= (yyvsp[(2) - (2)].node)->Set.CodePoints;
    (yyval.node)->Set.Breakout.Bytes |= (yyvsp[(2) - (2)].node)->Set.Breakout.Bytes;
  }
    break;

  case 80:
/* Line 1792 of yacc.c  */
#line 772 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = (yyvsp[(1) - (3)].node);
    (yyval.node)->Set.CodePoints &= (yyvsp[(3) - (3)].node)->Set.CodePoints;
    (yyval.node)->Set.Breakout.Bytes &= (yyvsp[(3) - (3)].node)->Set.Breakout.Bytes;
  }
    break;

  case 81:
/* Line 1792 of yacc.c  */
#line 778 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = (yyvsp[(1) - (3)].node);
    (yyval.node)->Set.CodePoints -= (yyvsp[(3) - (3)].node)->Set.CodePoints;
    (yyval.node)->Set.Breakout.Bytes -= (yyvsp[(3) - (3)].node)->Set.Breakout.Bytes;
  }
    break;

  case 82:
/* Line 1792 of yacc.c  */
#line 784 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = (yyvsp[(1) - (3)].node);
    (yyval.node)->Set.CodePoints ^= (yyvsp[(3) - (3)].node)->Set.CodePoints;
    (yyval.node)->Set.Breakout.Bytes ^= (yyvsp[(3) - (3)].node)->Set.Breakout.Bytes;
  }
    break;

  case 83:
/* Line 1792 of yacc.c  */
#line 790 "src/lib/re_grammar.ypp"
    {
    if ((yyvsp[(3) - (3)].c) <= (yyvsp[(1) - (3)].c)) {
      // x-y is ill-formed when y <= x
      throwError(
        {
          ParseError::REVERSED_CHAR_RANGE_BOUNDS,
          (yylsp[(1) - (3)]).first_column, (yylsp[(3) - (3)]).last_column,
          (yyvsp[(1) - (3)].c), (yyvsp[(3) - (3)].c)
        },
        ctx
      );
    }

    (yyval.node) = ctx->add(ParseNode::CHAR_CLASS, 'x');
    (yyval.node)->Set.CodePoints.insert((yyvsp[(1) - (3)].c), (yyvsp[(3) - (3)].c) + 1);
  }
    break;

  case 84:
/* Line 1792 of yacc.c  */
#line 807 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = (yyvsp[(3) - (3)].node);
    (yyval.node)->Set.CodePoints.insert((yyvsp[(1) - (3)].c), (yyvsp[(1) - (3)].c) + 1);
    (yyval.node)->Set.CodePoints.insert('-', '-' + 1);
  }
    break;

  case 85:
/* Line 1792 of yacc.c  */
#line 813 "src/lib/re_grammar.ypp"
    {
    if ((yyvsp[(3) - (3)].c) <= (yyvsp[(1) - (3)].c)) {
      // x-y is ill-formed when y <= x
      throwError(
        {
          ParseError::REVERSED_BYTE_RANGE_BOUNDS,
          (yylsp[(1) - (3)]).first_column, (yylsp[(3) - (3)]).last_column,
          (yyvsp[(1) - (3)].c), (yyvsp[(3) - (3)].c)
        },
        ctx
      );
    }

    (yyval.node) = ctx->add(ParseNode::CHAR_CLASS, 'x');
    (yyval.node)->Set.Breakout.Bytes.set((yyvsp[(1) - (3)].c), (yyvsp[(3) - (3)].c) + 1, true);
  }
    break;

  case 86:
/* Line 1792 of yacc.c  */
#line 830 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = (yyvsp[(3) - (3)].node);
    (yyval.node)->Set.Breakout.Bytes.set((yyvsp[(1) - (3)].c));
    (yyval.node)->Set.CodePoints.insert('-', '-' + 1);
  }
    break;

  case 88:
/* Line 1792 of yacc.c  */
#line 837 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = ctx->add(ParseNode::CHAR_CLASS, 'x');
    (yyval.node)->Set.CodePoints.set((yyvsp[(1) - (1)].c));
  }
    break;

  case 89:
/* Line 1792 of yacc.c  */
#line 842 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = ctx->add(ParseNode::CHAR_CLASS, 'x');
    (yyval.node)->Set.Breakout.Bytes.set((yyvsp[(1) - (1)].c));
  }
    break;

  case 90:
/* Line 1792 of yacc.c  */
#line 850 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = (yyvsp[(1) - (2)].node);
    (yyval.node)->Set.CodePoints |= (yyvsp[(2) - (2)].node)->Set.CodePoints;
    (yyval.node)->Set.Breakout.Bytes |= (yyvsp[(2) - (2)].node)->Set.Breakout.Bytes;
  }
    break;

  case 91:
/* Line 1792 of yacc.c  */
#line 856 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = (yyvsp[(1) - (3)].node);
    (yyval.node)->Set.CodePoints &= (yyvsp[(3) - (3)].node)->Set.CodePoints;
    (yyval.node)->Set.Breakout.Bytes &= (yyvsp[(3) - (3)].node)->Set.Breakout.Bytes;
  }
    break;

  case 92:
/* Line 1792 of yacc.c  */
#line 862 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = (yyvsp[(1) - (3)].node);
    (yyval.node)->Set.CodePoints -= (yyvsp[(3) - (3)].node)->Set.CodePoints;
    (yyval.node)->Set.Breakout.Bytes -= (yyvsp[(3) - (3)].node)->Set.Breakout.Bytes;
  }
    break;

  case 93:
/* Line 1792 of yacc.c  */
#line 868 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = (yyvsp[(1) - (3)].node);
    (yyval.node)->Set.CodePoints ^= (yyvsp[(3) - (3)].node)->Set.CodePoints;
    (yyval.node)->Set.Breakout.Bytes ^= (yyvsp[(3) - (3)].node)->Set.Breakout.Bytes;
  }
    break;

  case 95:
/* Line 1792 of yacc.c  */
#line 878 "src/lib/re_grammar.ypp"
    {
    if ((yyvsp[(3) - (3)].c) <= (yyvsp[(1) - (3)].c)) {
      // x-y is ill-formed when y <= x
      throwError(
        {
          ParseError::REVERSED_CHAR_RANGE_BOUNDS,
          (yylsp[(1) - (3)]).first_column, (yylsp[(3) - (3)]).last_column,
          (yyvsp[(1) - (3)].c), (yyvsp[(3) - (3)].c)
        },
        ctx
      );
    }

    (yyval.node) = ctx->add(ParseNode::CHAR_CLASS, 'x');
    (yyval.node)->Set.CodePoints.insert((yyvsp[(1) - (3)].c), (yyvsp[(3) - (3)].c) + 1);
  }
    break;

  case 96:
/* Line 1792 of yacc.c  */
#line 895 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = (yyvsp[(3) - (3)].node);
    (yyval.node)->Set.CodePoints.insert((yyvsp[(1) - (3)].c), (yyvsp[(1) - (3)].c) + 1);
    (yyval.node)->Set.CodePoints.insert('-', '-' + 1);
  }
    break;

  case 97:
/* Line 1792 of yacc.c  */
#line 901 "src/lib/re_grammar.ypp"
    {
    if ((yyvsp[(3) - (3)].c) <= (yyvsp[(1) - (3)].c)) {
      // x-y is ill-formed when y <= x
      throwError(
        {
          ParseError::REVERSED_BYTE_RANGE_BOUNDS,
          (yylsp[(1) - (3)]).first_column, (yylsp[(3) - (3)]).last_column,
          (yyvsp[(1) - (3)].c), (yyvsp[(3) - (3)].c)
        },
        ctx
      );
    }

    (yyval.node) = ctx->add(ParseNode::CHAR_CLASS, 'x');
    (yyval.node)->Set.Breakout.Bytes.set((yyvsp[(1) - (3)].c), (yyvsp[(3) - (3)].c) + 1, true);
  }
    break;

  case 98:
/* Line 1792 of yacc.c  */
#line 918 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = (yyvsp[(3) - (3)].node);
    (yyval.node)->Set.Breakout.Bytes.set((yyvsp[(1) - (3)].c));
    (yyval.node)->Set.CodePoints.insert('-', '-' + 1);
  }
    break;

  case 100:
/* Line 1792 of yacc.c  */
#line 925 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = ctx->add(ParseNode::CHAR_CLASS, 'x');
    (yyval.node)->Set.CodePoints.set((yyvsp[(1) - (1)].c));
  }
    break;

  case 101:
/* Line 1792 of yacc.c  */
#line 930 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = ctx->add(ParseNode::CHAR_CLASS, 'x');
    (yyval.node)->Set.CodePoints.set('-');
  }
    break;

  case 102:
/* Line 1792 of yacc.c  */
#line 935 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = ctx->add(ParseNode::CHAR_CLASS, 'x');
    (yyval.node)->Set.Breakout.Bytes.set((yyvsp[(1) - (1)].c));
  }
    break;

  case 103:
/* Line 1792 of yacc.c  */
#line 943 "src/lib/re_grammar.ypp"
    {
    (yyval.c) = ']';
  }
    break;

  case 104:
/* Line 1792 of yacc.c  */
#line 947 "src/lib/re_grammar.ypp"
    {
    (yyval.c) = '-';
  }
    break;

  case 106:
/* Line 1792 of yacc.c  */
#line 955 "src/lib/re_grammar.ypp"
    {
    (yyval.c) = '^';
  }
    break;

  case 110:
/* Line 1792 of yacc.c  */
#line 965 "src/lib/re_grammar.ypp"
    {
    (yyval.c) = '|';
  }
    break;

  case 111:
/* Line 1792 of yacc.c  */
#line 969 "src/lib/re_grammar.ypp"
    {
    (yyval.c) = '(';
  }
    break;

  case 112:
/* Line 1792 of yacc.c  */
#line 973 "src/lib/re_grammar.ypp"
    {
    (yyval.c) = ')';
  }
    break;

  case 113:
/* Line 1792 of yacc.c  */
#line 977 "src/lib/re_grammar.ypp"
    {
    (yyval.c) = '?';
  }
    break;

  case 114:
/* Line 1792 of yacc.c  */
#line 981 "src/lib/re_grammar.ypp"
    {
    (yyval.c) = '+';
  }
    break;

  case 115:
/* Line 1792 of yacc.c  */
#line 985 "src/lib/re_grammar.ypp"
    {
    (yyval.c) = '*';
  }
    break;

  case 116:
/* Line 1792 of yacc.c  */
#line 989 "src/lib/re_grammar.ypp"
    {
    (yyval.c) = '.';
  }
    break;

  case 117:
/* Line 1792 of yacc.c  */
#line 993 "src/lib/re_grammar.ypp"
    {
    (yyval.c) = '{';
  }
    break;

  case 118:
/* Line 1792 of yacc.c  */
#line 997 "src/lib/re_grammar.ypp"
    {
    (yyval.c) = '}';
  }
    break;

  case 119:
/* Line 1792 of yacc.c  */
#line 1001 "src/lib/re_grammar.ypp"
    {
    (yyval.c) = ',';
  }
    break;

  case 120:
/* Line 1792 of yacc.c  */
#line 1005 "src/lib/re_grammar.ypp"
    {
    (yyval.c) = '<';
  }
    break;

  case 121:
/* Line 1792 of yacc.c  */
#line 1009 "src/lib/re_grammar.ypp"
    {
    (yyval.c) = '=';
  }
    break;

  case 122:
/* Line 1792 of yacc.c  */
#line 1013 "src/lib/re_grammar.ypp"
    {
    (yyval.c) = '!';
  }
    break;

  case 123:
/* Line 1792 of yacc.c  */
#line 1017 "src/lib/re_grammar.ypp"
    {
    (yyval.c) = '$';
  }
    break;

  case 124:
/* Line 1792 of yacc.c  */
#line 1021 "src/lib/re_grammar.ypp"
    {
    (yyval.c) = '\b';
  }
    break;

  case 125:
/* Line 1792 of yacc.c  */
#line 1028 "src/lib/re_grammar.ypp"
    {
    (yyval.node) = ctx->add(ParseNode::CHAR_CLASS, ctx->USet);
  }
    break;


/* Line 1792 of yacc.c  */
#line 3099 "src/lib/re_grammar.cpp"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, ctx, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, ctx, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc, ctx);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp, ctx);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, ctx, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, ctx);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp, ctx);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2055 of yacc.c  */
#line 1033 "src/lib/re_grammar.ypp"


namespace {

  template <typename F>
  int consumeSingleton(F func, yytokentype type, YYSTYPE* yylval, Context* ctx) {
    const int val = func(ctx->Text, ctx->TextEnd);
    if (val < 0) {
      return BAD;
    }
    else {
      yylval->c = val;
      return type;
    }
  }

  template <typename F>
  int consumeSet(F func, YYSTYPE* yylval, Context* ctx) {
    const int val = func(ctx->Text, ctx->TextEnd, ctx->USet);
    if (val < 0) {
      return BAD;
    }
    else {
      yylval->s = &ctx->USet;
      return SET;
    }
  }

// FIXME: Add \c.

  int consumeEscape(YYSTYPE* yylval, Context* ctx) {
    if (ctx->Text >= ctx->TextEnd) {
      return BAD;
    }

    const int c = *ctx->Text++;
    switch (c) {
    // metacharacters as themselves
    case '|':
    case '(':
    case ')':
    case '?':
    case '+':
    case '*':
    case '.':
    case '[':
    case ']':
    case '^':
    case '$':
    case '-':
    case '{':
    case '}':
    case '&':
    case '~':
    case '<':
    case '=':
    case '!':
    case '\\':
      yylval->c = c;
      return CHAR;

    // ASCII escapes
    case 'a':
      yylval->c = '\a';
      return CHAR;
    case 'e':
      yylval->c = 0x1B;
      return CHAR;
    case 'f':
      yylval->c = '\f';
      return CHAR;
    case 'n':
      yylval->c = '\n';
      return CHAR;
    case 'r':
      yylval->c = '\r';
      return CHAR;
    case 't':
      yylval->c = '\t';
      return CHAR;

    // named character classes
    case 'd':
      ctx->USet.reset();
      ctx->USet.insert('0', '9' + 1);
      yylval->s = &ctx->USet;
      return SET;

    case 'D':
      ctx->USet.reset();
      ctx->USet.insert('0', '9' + 1);
      ctx->USet.flip();
      yylval->s = &ctx->USet;
      return SET;

    case 's':
      ctx->USet.reset();
      ctx->USet.set('\t');
      ctx->USet.set('\n');
      ctx->USet.set('\f');
      ctx->USet.set('\r');
      ctx->USet.set(' ');
      yylval->s = &ctx->USet;
      return SET;

    case 'S':
      ctx->USet.reset();
      ctx->USet.set('\t');
      ctx->USet.set('\n');
      ctx->USet.set('\f');
      ctx->USet.set('\r');
      ctx->USet.set(' ');
      ctx->USet.flip();
      yylval->s = &ctx->USet;
      return SET;

    case 'w':
      ctx->USet.reset();
      ctx->USet.insert('0', '9' + 1);
      ctx->USet.insert('A', 'Z' + 1);
      ctx->USet.set('_');
      ctx->USet.insert('a', 'z' + 1);
      yylval->s = &ctx->USet;
      return SET;

    case 'W':
      ctx->USet.reset();
      ctx->USet.insert('0', '9' + 1);
      ctx->USet.insert('A', 'Z' + 1);
      ctx->USet.set('_');
      ctx->USet.insert('a', 'z' + 1);
      ctx->USet.flip();
      yylval->s = &ctx->USet;
      return SET;

    // hexadecimal characters
    case 'x':
      if (ctx->Text == ctx->TextEnd) {
        return BAD;
      }
      else if (*ctx->Text == '{') {
        ++ctx->Text;
        return consumeSingleton(parseHexCodePoint<const int*>, CHAR, yylval, ctx);
      }
      else {
        return consumeSingleton(parseHexByte<const int*>, CHAR, yylval, ctx);
      }

    // breakout bytes
    case 'z':
      return consumeSingleton(parseHexByte<const int*>, BYTE, yylval, ctx);

    // octal characters
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
      --ctx->Text;
      return consumeSingleton(parseOctByte<const int*>, CHAR, yylval, ctx);

    // named Unicode code points
    case 'N':
      return consumeSingleton(parseNamedCodePoint<const int*>, CHAR, yylval, ctx);

    // Unicode properties
    case 'p':
    case 'P':
      ctx->Text -= 2;
      return consumeSet(parseProperty<const int*>, yylval, ctx);

    // assertions
    case 'A':
      return TEXT_START;
    case 'B':
      return NON_WORD_BOUNDARY;
    case 'K':
      return KILL;
    case 'Z':
      return TEXT_END;
    case 'b':
      return WHACK_LITTLE_B; // NB: Also an ASCII escape inside CCs

    default:
      return BAD;
    }
  }

  int yylex(YYSTYPE* yylval, YYLTYPE* yylloc, Context* ctx) {
    yylloc->first_column = ctx->Text - ctx->TextBegin;

    ctx->TokenType = -1;  // EOF

    if (ctx->Text < ctx->TextEnd) {
      const int c = *ctx->Text++;
      yylloc->last_column = yylloc->first_column + 1;
      if (c < 1) {
        //   -1 indicates bogus UTF-8
        //    0 is a prohibited mid-string null byte
        ctx->TokenType = BAD;
      }
      else if (ctx->LiteralMode) {
        yylval->c = c;
        ctx->TokenType = CHAR;
      }
      else {
        switch (c) {
        case '|':
        case '(':
        case ')':
        case '?':
        case '+':
        case '*':
        case '.':
        case '[':
        case ']':
        case '^':
        case '$':
        case '{':
        case '}':
        case ',':
        case '<':
        case '=':
        case '!':
          ctx->TokenType = c;
          break;
        case '&':
          if (ctx->Text < ctx->TextEnd && *ctx->Text == '&') {
              // give the parser a hint that this amp might be an intersection
              yylloc->last_column = ++ctx->Text - ctx->TextBegin;
              ctx->TokenType = AMP_AMP;
          }
          else {
            // give the parser a hint that this ampersand is a literal
            yylval->c = c;
            ctx->TokenType = CHAR;
          }
          break;
        case '~':
          if (ctx->Text < ctx->TextEnd && *ctx->Text == '~') {
            // give the parser a hint that this tilde might be an XOR
            yylloc->last_column = ++ctx->Text - ctx->TextBegin;
            ctx->TokenType = TILDE_TILDE;
          }
          else {
            // give the parser a hint that this tilde is a literal
            yylval->c = c;
            ctx->TokenType = CHAR;
          }
          break;
        case '-':
          if (ctx->Text < ctx->TextEnd) {
            switch (*ctx->Text) {
            case ']':
              // give the parser a hint that this hypen is a literal
              yylval->c = c;
              ctx->TokenType = CHAR;
              break;
            case '-':
              // give the parser a hint that this hypen might be a minus
              yylloc->last_column = ++ctx->Text - ctx->TextBegin;
              ctx->TokenType = HYPHEN_HYPHEN;
              break;
            default:
              // this hyphen might be a range operator if inside a cc
              ctx->TokenType = '-';
              break;
            }
          }
          else {
            yylval->c = c;
            ctx->TokenType = CHAR;
          }
          break;
        case '\\':
          ctx->TokenType = consumeEscape(yylval, ctx);
          yylloc->last_column = ctx->Text - ctx->TextBegin;
          break;
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
        case '8':
        case '9':
          yylval->c = c;
          ctx->TokenType = DIGIT;
          break;
        default:
          yylval->c = c;
          ctx->TokenType = CHAR;
          break;
        }
      }
    }

    return ctx->TokenType;
  }

  void yyerror(YYLTYPE* yylloc, Context* ctx, const char*) {
    /*
       NB: We do not call yyerror ourselves, in order to ensure that if
       control arrives here, it happened due to a syntax error detected
       by bison (as opposed to a semantic error we detect in one of the
       parse rules. This lets us deduce which error we have by examining
       the state of the parser.
    */

    if (ctx->TokenType == BAD) {
      // The token read was something invalid.
      ParseError e{
        ParseError::INVALID_ESCAPE,
        yylloc->first_column,
        yylloc->last_column
      };

      throwError(e, ctx);
    }
    else if (yylloc->first_column == yylloc->last_column) {
      // We ran off the end of the pattern looking for a matching delimiter.
      // We return rather than throw here to let the error recovery action
      // execute. The error recovery action knows the location of the
      // unmatched delimiter.
      return;
    }
    else {
      // The only remaining way to fail is a repetition operator
      // following a non-atom.
      ParseError e{
        ParseError::NONATOMIC_REPETITON,
        yylloc->first_column,
        yylloc->last_column
      };

      throwError(e, ctx);
    }
  }

  void throwError(ParseError e, Context* ctx) {
    std::ostringstream ss;

    switch (e.Type) {
    case ParseError::NONATOMIC_REPETITON:
      ss << "repetition of non-atom by ";
      break;
    case ParseError::REVERSED_REPETITION_BOUNDS:
      ss << e.First << " > " << e.Second << " in ";
      break;
    case ParseError::INVALID_ESCAPE:
      ss << "invalid escape ";
      break;
    case ParseError::UNMATCHED_PARENTHESIS:
      ss << "unmatched left parenthesis ";
      break;
    case ParseError::UNMATCHED_BRACKET:
      ss << "unmatched left bracket ";
      break;
    case ParseError::EMPTY_CHAR_CLASS:
      ss << "empty character class ";
      break;
    case ParseError::REVERSED_CHAR_RANGE_BOUNDS:
      ss << "U+" << std::hex << std::uppercase
         <<  e.First << " >= U+" << e.Second << std::dec << " in ";
      break;
    case ParseError::REVERSED_BYTE_RANGE_BOUNDS:
      ss << "0x" << std::hex << std::uppercase << std::setfill('0')
         << std::setw(2) << e.First << " >= 0x"
         << std::setw(2) << e.Second << std::dec << " in ";
      break;
    case ParseError::SET_OPERATOR_MISSING_OPERAND:
      ss << "missing operand for ";
      break;
    }

    std::copy(
      ctx->TextBegin + e.Begin,
      ctx->TextBegin + e.End,
      std::ostream_iterator<char>(ss)
    );

    ss << ", at [" << e.Begin << ',' << e.End << ')';

    THROW_RUNTIME_ERROR_WITH_CLEAN_OUTPUT(ss.str());
  }
}

bool parse(const Pattern& p, ParseTree& tree) {
  std::vector<int> cp;
  cp.reserve(p.Expression.size()); // upper bound, no resizing
  transform_utf8_to_unicode(
    p.Expression.begin(), p.Expression.end(), std::back_inserter(cp)
  );

  Context ctx;

  ctx.LiteralMode = p.FixedString;
  ctx.CaseInsensitive = p.CaseInsensitive;

  ctx.TextBegin = ctx.Text = cp.data();
  ctx.TextEnd = ctx.Text + cp.size();

  ctx.Tree = &tree;
  ctx.Tree->init(cp.size());

#if YYDEBUG
  yydebug = 1;
#endif

  return yyparse(&ctx) == 0;
}
